package txttv.com;
	 
import android.app.Activity;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.database.sqlite.SQLiteStatement;
import android.util.Log;

import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import android.database.sqlite.SQLiteDatabase;

public class tietokanta extends Activity {

	private SQLiteDatabase db;
	private Cursor kursori;

	
	public boolean OnkoBookmarkSivulla(int sivuid, int syvyys){
		this.kursori = this.db.query("bookmark", null, null, null, null, null, null);
		this.kursori.moveToFirst();
        while (this.kursori.isAfterLast() == false) {
        	if ((this.kursori.getInt(1) == sivuid) && (this.kursori.getInt(2) == syvyys)){
        		return true;
        	}
        	this.kursori.moveToNext();
        }
        
        return false;
	}

	
	public boolean OnkoAlarmiSivulla(int sivuid, int syvyys){
		this.kursori = this.db.query("pagealert", null, null, null, null, null, null);
		this.kursori.moveToFirst();
        while (this.kursori.isAfterLast() == false) {
        	if ((this.kursori.getInt(1) == sivuid) && (this.kursori.getInt(2) == syvyys)){
        		return true;
        	}
        	this.kursori.moveToNext();
        }
        
        return false;
	}
	
	
	public void LaitaSivu(int sivuid, String sivudata, int syvyys, int totalsyvyys){
		
		// FIXME!!!!!!!!!!!!!!!! Temporary solution!
		this.db.execSQL("DELETE FROM content WHERE page="+Integer.toString(sivuid)
				+ " AND depth="+Integer.toString(syvyys));
		
	    ContentValues value = new ContentValues();
        value.put("server", 0);
        value.put("page", sivuid);
        value.put("depth", syvyys);
        value.put("data", sivudata);
        value.put("totalsyvyys", totalsyvyys);
        
        this.db.insert("content", null, value);
	}
	
	public int SwitchPageAlert(int sivuid, int syvyys){
		boolean loyty = false;
		this.kursori = this.db.query("pagealert", null, null, null, null, null, null);
		this.kursori.moveToFirst();
        while (this.kursori.isAfterLast() == false) {
        	if (this.kursori.getInt(1) == sivuid){
        		loyty = true;
        	}
        	this.kursori.moveToNext();
        }
        
        if (loyty){
        	this.db.execSQL("DELETE FROM pagealert WHERE page="+Integer.toString(sivuid)+
        			" and syvyys="+Integer.toString(syvyys));
        	return 0;
        } else {

    	    ContentValues value = new ContentValues();
            value.put("page", sivuid);
            value.put("syvyys", syvyys);
            this.db.insert("pagealert", null, value);
            return 1;
        }
	}

	public void TyhjennaContent(){
		this.db.execSQL("DELETE FROM content;");
	}
	
	public int SwitchBookMark(int sivuid, int syvyys){
		boolean loyty = false;
		this.kursori = this.db.query("bookmark", null, null, null, null, null, null);
		this.kursori.moveToFirst();
        while (this.kursori.isAfterLast() == false) {
        	if (this.kursori.getInt(1) == sivuid){
        		loyty = true;
        	}
        	this.kursori.moveToNext();
        }
        
        if (loyty){
        	this.db.execSQL("DELETE FROM bookmark WHERE page="+Integer.toString(sivuid)+
        			" and syvyys="+Integer.toString(syvyys));
        	return 0;
        } else {

    	    ContentValues value = new ContentValues();
            value.put("page", sivuid);
            value.put("syvyys", syvyys);
            this.db.insert("bookmark", null, value);
            return 1;
        }
	}
	
	public int[][] HaeAlertit(){
		
		int laskuri = 0;
		this.kursori = this.db.query("pagealert", null, null, null, null, null, null);
		this.kursori.moveToFirst();
        while (this.kursori.isAfterLast() == false) {
        	laskuri++;
        	this.kursori.moveToNext();
        }
		

        final int[][] palautettava = new int[laskuri][2];
        
        int i=0;
		this.kursori = this.db.query("pagealert", null, null, null, null, null, null);
		this.kursori.moveToFirst();
        while (this.kursori.isAfterLast() == false) {
        	palautettava[i][0] = this.kursori.getInt(1);
        	palautettava[i][1] = this.kursori.getInt(2);
        	i++;
        	this.kursori.moveToNext();
        }
        
		return palautettava;
	}

	public CharSequence[] HaeBookmarkit(){
		
		
		int laskuri = 0;
		this.kursori = this.db.query("bookmark", null, null, null, null, null, null);
		this.kursori.moveToFirst();
        while (this.kursori.isAfterLast() == false) {
        	laskuri++;
        	this.kursori.moveToNext();
        }
		

        final CharSequence[] palautettava = new CharSequence[laskuri];
        
        int i=0;
		this.kursori = this.db.query("bookmark", null, null, null, null, null, null);
		this.kursori.moveToFirst();
        while (this.kursori.isAfterLast() == false) {
        	palautettava[i] = this.kursori.getString(1);
        	i++;
        	this.kursori.moveToNext();
        }
        
		return palautettava;
	}
	
	public int HaeSyvyys(int sivuid, int syvyys){
		this.kursori = this.db.query("content", null, null, null, null, null, null);
		this.kursori.moveToFirst();
        while (this.kursori.isAfterLast() == false) {
        	if ((this.kursori.getInt(2) == sivuid) & (this.kursori.getInt(3) == syvyys)){
        		return this.kursori.getInt(5);
        	}
        	this.kursori.moveToNext();
        }
        return 1;
	}

	public String HaeSivu(int sivuid, int syvyys){
		this.kursori = this.db.query("content", null, null, null, null, null, null);
		this.kursori.moveToFirst();
        while (this.kursori.isAfterLast() == false) {
        	if ((this.kursori.getInt(2) == sivuid) & (this.kursori.getInt(3) == syvyys)){
        		return this.kursori.getString(4);
        	}
        	this.kursori.moveToNext();
        }
        return "VIRHE";
	}
	
	public tietokanta(Context context) {

		
		try {
			this.db = context.openOrCreateDatabase("data.db", SQLiteDatabase.CREATE_IF_NECESSARY, null);

			this.db.execSQL("CREATE TABLE content " + 
      		 "(id INTEGER PRIMARY KEY, " +
      		 "server INTEGER, " +
      		 "page  INTEGER, " +
      		 "depth INTEGER, " +             
      		 "data TEXT, " +
      		 "totalsyvyys INTEGER)");

		    this.db.execSQL("CREATE TABLE bookmark " + 
		      		 "(id INTEGER PRIMARY KEY, " +
		      		 "page INTEGER, syvyys INTEGER) ");
			
		    this.db.execSQL("CREATE TABLE pagealert " + 
		      		 "(id INTEGER PRIMARY KEY, " +
		      		 "page INTEGER, syvyys INTEGER) ");

		    this.db.setVersion(1);
	        this.db.setLocale(Locale.getDefault());
	        this.db.setLockingEnabled(true);
			
		} catch (SQLException e){
			
		}
        
	}
	      
}