package txttv.com;


import java.io.FileNotFoundException;
import java.util.Locale;

import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import txttv.com.nettiwork;
import txttv.com.tietokanta;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.ContentValues;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.view.GestureDetector;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.GestureDetector.SimpleOnGestureListener;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.TextView.OnEditorActionListener;

public class txttv extends Activity {
	WebView browser;
	private EditText sivu;
	private ImageButton ylos;
	private ImageButton alas;
	private ImageButton vasen;
    private GestureDetector gestureDetector;
    View.OnTouchListener gestureListener;
	private ImageButton oikea;
	private tietokanta sivutietokanta = null;
	private nettiwork nettivehje = null;
	private int lassssssssssskin = 0;
	private int syvyys = 1;
	private int cur_syvyys = 1;
	private timeri ajastin = null;
	private NotificationManager noti = null;
	private static final String[] COLS = new String[]
	                                                   {"id","server", "page", "depth", "data"};
	  
	// hei
	
	View.OnClickListener ylos_buttonListener = new View.OnClickListener(){
		@Override
		public void onClick(View v){
			cur_syvyys++;
			if (cur_syvyys>syvyys) cur_syvyys=syvyys;
			if (cur_syvyys == syvyys)
			{
			       ylos.setVisibility(View.INVISIBLE);
			}
			else
			{
			       ylos.setVisibility(View.VISIBLE);
			}
			
			if(cur_syvyys > 1) alas.setVisibility(View.VISIBLE);
			int page = Integer.parseInt(sivu.getText().toString());
			browser.loadData(ProsessoiSivu(page), "text/html","UTF-8");
		}
	};

	
	View.OnClickListener alas_buttonListener = new View.OnClickListener(){
		@Override
		public void onClick(View v){
			int page = Integer.parseInt(sivu.getText().toString());
			if (cur_syvyys > 2){
				cur_syvyys--;
				alas.setVisibility(View.VISIBLE);
			}
			else
			{
				alas.setVisibility(View.INVISIBLE);
				cur_syvyys = 1;
			}
			if(syvyys > 1) ylos.setVisibility(View.VISIBLE);
			browser.loadData(ProsessoiSivu(page), "text/html","UTF-8");
		}
	};
	
	
	View.OnClickListener vasen_buttonListener = new View.OnClickListener(){
		@Override
		public void onClick(View v){
			int page = Integer.parseInt(sivu.getText().toString())-1;
			if (page < 100) page = 100;
			sivu.setText(Integer.toString(page));
			cur_syvyys = 1;
			browser.loadData(ProsessoiSivu(page), "text/html","UTF-8");
			
		}
	};

	
	View.OnClickListener oikea_buttonListener = new View.OnClickListener(){
		@Override
		public void onClick(View v){
			int page = Integer.parseInt(sivu.getText().toString())+1;
			if (page > 899) page = 899;
			sivu.setText(Integer.toString(page));
			cur_syvyys = 1;
			browser.loadData(ProsessoiSivu(page), "text/html","UTF-8");
		}
	};
	
	public void TarkastaPageAlertit(){
		//Toast.makeText(getApplicationContext(), "jaujaujau ;) !", Toast.LENGTH_SHORT).show();
		
		int lista[][] = this.sivutietokanta.HaeAlertit();
		
		int i=0;
		for (i=0;i<lista.length;i++){
			int sivuid = lista[i][0];
			int depth = lista[i][1];
			
			String uusi_tietodata = this.nettivehje.LataaSivu("http://admanusproptia.fi/kray/tekstitv/taikuri.php", sivuid, depth);

			String vanha_tietodata = this.sivutietokanta.HaeSivu(sivuid, depth);
			
			if (vanha_tietodata != "VIRHE"){
				if (!uusi_tietodata.equalsIgnoreCase(vanha_tietodata)){

					// Wuhuu!!! Sivu muuttunut!!!
					int totald = Integer.parseInt(uusi_tietodata.substring(0, 1));
					
					this.sivutietokanta.LaitaSivu(sivuid, uusi_tietodata, depth, totald);
					
					// Fire the alert!
					this.naytanoti(sivuid);
					
				}
				
			}
			
		}
	}
	
	private class Callback extends WebViewClient {
		public boolean shouldOverrideUrlLoading(WebView view, String url) {
			
			sivu.setText(url.substring(32,35));
			
			int page = Integer.parseInt(sivu.getText().toString());
			
			cur_syvyys = 1;
			browser.loadData(ProsessoiSivu(page), "text/html","UTF-8");
			
			return(true);
		}
	}

	private void ParsiSyvyysEest(String rivi){
		
		String syvyyyys = rivi.substring(0,1);
		this.syvyys = Integer.parseInt(syvyyyys); 
		//sivutieto = sivutieto.substring(1);
		//this.syvyys = this.sivutietokanta.HaeSyvyys(Integer.parseInt(sivu.getText().toString()), this.cur_syvyys);
		
		if ((this.syvyys > 1) && (this.cur_syvyys < this.syvyys))
			ylos.setVisibility(View.VISIBLE);
		else
			ylos.setVisibility(View.INVISIBLE);


		if ((this.syvyys > 1) && (this.cur_syvyys > 1))
			alas.setVisibility(View.VISIBLE);
		else
			alas.setVisibility(View.INVISIBLE);
	}
	
	private String ProsessoiSivu(int sivunumero){
		
		String sivutieto = this.sivutietokanta.HaeSivu(sivunumero,cur_syvyys);
		
		if (sivutieto == "VIRHE"){
			
			sivutieto = this.nettivehje.LataaSivu("http://admanusproptia.fi/kray/tekstitv/taikuri.php", sivunumero, cur_syvyys);
			
			ParsiSyvyysEest(sivutieto);
			sivutieto = sivutieto.substring(1,sivutieto.length());
			this.sivutietokanta.LaitaSivu(sivunumero, sivutieto, cur_syvyys, syvyys);
				
		}

		browser.loadData(sivutieto, "text/html","UTF-8");
		return sivutieto;
	}
	
	public class timeri extends CountDownTimer{
		public timeri(long milli, long interval){
			super(milli, interval);
		}
		
		@Override
		public void onFinish(){
			this.start();
		}
		
		@Override
		public void onTick(long milli){
			TarkastaPageAlertit();
		}
	}
	
	public void BookMarkPage(){
		int page = Integer.parseInt(sivu.getText().toString());
		
		switch (this.sivutietokanta.SwitchBookMark(page,cur_syvyys)){
		case 1:
			Toast.makeText(getApplicationContext(), "Bookmark Added!", Toast.LENGTH_SHORT).show();
			return;
		case 0:
			Toast.makeText(getApplicationContext(), "Bookmark Removed!", Toast.LENGTH_SHORT).show();
			return;
		}
	}

	public void RefreshPage(){
		int page = Integer.parseInt(sivu.getText().toString());
		String tieto = this.nettivehje.LataaSivu("http://admanusproptia.fi/kray/tekstitv/taikuri.php", page, cur_syvyys);
		ParsiSyvyysEest(tieto);
		tieto = tieto.substring(1);
		this.sivutietokanta.LaitaSivu(page, tieto, cur_syvyys, syvyys);
		browser.loadData(ProsessoiSivu(page), "text/html","UTF-8");
		browser.setInitialScale(90);
		
	}
	
	public void PageAlertPage(){
		
		int page = Integer.parseInt(sivu.getText().toString());
		
		switch (this.sivutietokanta.SwitchPageAlert(page,syvyys)){
		case 1:
			Toast.makeText(getApplicationContext(), "Page-Alert Added!", Toast.LENGTH_SHORT).show();
			return;
		case 0:
			Toast.makeText(getApplicationContext(), "Page-Alert Removed!", Toast.LENGTH_SHORT).show();
			return;
		}
	}
	
	public void ListBookMarks(){
		final CharSequence[] items = this.sivutietokanta.HaeBookmarkit();

		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle("Select bookmark");
		builder.setItems(items, new DialogInterface.OnClickListener() {
		    public void onClick(DialogInterface dialog, int item) {
		        
		    	Toast.makeText(getApplicationContext(), items[item], Toast.LENGTH_SHORT).show();
		        
		        sivu.setText(items[item]);
		        
    			cur_syvyys = 1;
		        browser.loadData(
		        		ProsessoiSivu(
		        				Integer.parseInt(items[item].toString())
		        				),
		        		"text/html",
		        		"UTF-8");
		        
		    }
		});
		AlertDialog alert = builder.create();
		alert.show();
	}

	public boolean onOptionsItemSelected(MenuItem item){
		switch (item.getItemId()){
		case 1:
			this.BookMarkPage();
			return true;
		case 2:
			this.RefreshPage();
			return true;
		case 3:
			this.sivutietokanta.TyhjennaContent();
			this.finish();
			return false;
		case 4:
			this.ListBookMarks();
			return true;
		case 5:
			this.PageAlertPage();
			return true;
		}
		return false;
	}
	
	class MyGestureDetector extends SimpleOnGestureListener {
	    @Override
	    public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX, float velocityY) {
	        try {
	            if (Math.abs(e1.getY() - e2.getY()) > 250)
	                return false;
	            // right to left swipe
	            if(e1.getX() - e2.getX() > 120 && Math.abs(velocityX) > 200) {
	    			int page = Integer.parseInt(sivu.getText().toString())-1;
	    			if (page < 100) page = 100;
	    			cur_syvyys = 1;
	    			sivu.setText(Integer.toString(page));
	    			browser.loadData(ProsessoiSivu(page), "text/html","UTF-8");
	            	
	            }  else if (e2.getX() - e1.getX() > 120 && Math.abs(velocityX) > 200) {
	    			int page = Integer.parseInt(sivu.getText().toString())+1;
	    			if (page > 899) page = 899;
	    			cur_syvyys = 1;
	    			sivu.setText(Integer.toString(page));
	    			browser.loadData(ProsessoiSivu(page), "text/html","UTF-8");
	            }
	            
	            else if(e1.getY() - e2.getY() > 120 && Math.abs(velocityY) > 200){
	            	cur_syvyys++;
	    			if (cur_syvyys>syvyys) cur_syvyys=syvyys;
	    			if (cur_syvyys == syvyys)
	    			{
	    			       ylos.setVisibility(View.INVISIBLE);
	    			}
	    			else
	    			{
	    			       ylos.setVisibility(View.VISIBLE);
	    			}
	    			if(cur_syvyys > 1) alas.setVisibility(View.VISIBLE);
	    			int page = Integer.parseInt(sivu.getText().toString());
	    			browser.loadData(ProsessoiSivu(page), "text/html","UTF-8");
	            }
	            
	            else if(e2.getY() - e1.getY() > 120 && Math.abs(velocityY) > 200){
	            	int page = Integer.parseInt(sivu.getText().toString());
	    			if (cur_syvyys > 2){
	    				cur_syvyys--;
	    				alas.setVisibility(View.VISIBLE);
	    			}
	    			else
	    			{
	    				alas.setVisibility(View.INVISIBLE);
	    				cur_syvyys = 1;
	    			}
	    			if(syvyys > 1) ylos.setVisibility(View.VISIBLE);
	    			browser.loadData(ProsessoiSivu(page), "text/html","UTF-8");	            }
	            
	        } catch (Exception e) {
	            // nothing
	        }
	        return false;
	    }
	}
	
	@Override
	public boolean onPrepareOptionsMenu(Menu menu){
		// HeI
		menu.clear();
		int alarmikoni = R.drawable.alarmd;
		int bookikoni = R.drawable.bookmark;
		int page = Integer.parseInt(sivu.getText().toString());
		
		if (this.sivutietokanta.OnkoBookmarkSivulla(page, cur_syvyys)){
			bookikoni = R.drawable.bookmark2;
		}

		if (this.sivutietokanta.OnkoAlarmiSivulla(page, cur_syvyys)){
			alarmikoni = R.drawable.alarmd2;
		}
		
 		menu.add(0, 1, 0, "Bookmark").setIcon(bookikoni);
 		menu.add(0, 4, 0, "List Bookmarks").setIcon(R.drawable.bookmark_folder);
 		menu.add(0, 5, 0, "Page Alerter").setIcon(alarmikoni);
 		menu.add(0, 2, 0, "Refresh").setIcon(R.drawable.rel);
 		menu.add(0, 3, 0, "Quit").setIcon(R.drawable.shutdown);
 		// HEIII!!!!!
 		return super.onCreateOptionsMenu(menu);
 	}	
	
	public void naytanoti(int sivuid){
		Intent intent = new Intent(this, txttv.class);
		
		Notification n = new Notification(R.drawable.tv, "Viesti", System.currentTimeMillis());
		n.setLatestEventInfo(txttv.this, "TXTTV", "Page "+sivuid+" has changed!",PendingIntent.getActivity(this.getBaseContext(), 0, intent, PendingIntent.FLAG_CANCEL_CURRENT));
		sivu.setText(Integer.toString(sivuid));
		noti.notify(this.lassssssssssskin ,n);
		this.lassssssssssskin++;
		
	}
	
	public void paivita_bookmark_db(){
		CharSequence hmt[] = this.sivutietokanta.HaeBookmarkit();
		
		int i;
		for (i=0;i<hmt.length;i++){
			
			
			String uustieto = this.nettivehje.LataaSivu("http://admanusproptia.fi/kray/tekstitv/taikuri.php",
					Integer.parseInt(hmt[i].toString()),
					1);
			
			this.sivutietokanta.LaitaSivu(Integer.parseInt(hmt[i].toString()), uustieto, 1, Integer.parseInt(uustieto.substring(0, 1)));
			
		}
		
	}
	
		/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
            

        
        browser = (WebView) findViewById(R.id.webkit);
        browser.setWebViewClient(new Callback());
        browser.getSettings().setLayoutAlgorithm(WebSettings.LayoutAlgorithm.SINGLE_COLUMN);

        ajastin = new timeri(600000, 300000);
        ajastin.start();
        
        noti = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
        
        gestureDetector = new GestureDetector(new MyGestureDetector());
        gestureListener = new View.OnTouchListener() {
            public boolean onTouch(View v, MotionEvent event) {
                if (gestureDetector.onTouchEvent(event)) {
                    return true;
                }
                return false;
            }
        };

        
        // HYVT NAISET JA HERRAT, KONTEKSTIA PIT KSITELL OIKEIN!!
        // 1) L LUO KONTEKSTIA TYHJST, SE EI VIITTAA MIHINKN
        // 2) KYT OIKEAA KONTEKSTIA, NYT SIIS SOVELLUKSEMME
        // 3) JOS KYTT TYHJ, LAITA SE NYT AINAKIN VIITTAAMAAN LOPULTA SOVELLUKSEEN
        this.sivutietokanta = new tietokanta(this);
        this.nettivehje = new nettiwork(this);
        
        this.vasen = (ImageButton) findViewById(R.id.vasen);
        vasen.setOnClickListener(vasen_buttonListener);	

        this.oikea = (ImageButton) findViewById(R.id.oikea);
        oikea.setOnClickListener(oikea_buttonListener);	
        
        this.alas = (ImageButton) findViewById(R.id.alas);
        alas.setOnClickListener(alas_buttonListener);	

        this.ylos = (ImageButton) findViewById(R.id.ylos);
        ylos.setOnClickListener(ylos_buttonListener);	

        this.sivu = (EditText) this.findViewById(R.id.sivu);
       // sivu.setVisibility(View.VISIBLE);
       // sivu.setVisibility(View.INVISIBLE);
        alas.setVisibility(View.INVISIBLE);
        ylos.setVisibility(View.INVISIBLE);
        sivu.setOnEditorActionListener(new OnEditorActionListener(){

			@Override
			public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
				cur_syvyys = 1;
				int page = Integer.parseInt(sivu.getText().toString());	
				sivu.setText(Integer.toString(page));
				browser.loadData(ProsessoiSivu(page), "text/html","UTF-8");
				return false;
			}
        	
        	
        });
        
        //browser.setOnClickListener(txttv.this); 
        browser.setOnTouchListener(gestureListener);

        this.paivita_bookmark_db();
        this.RefreshPage();
    }
}